<?php

/**
 * This project has been generated by nuts generator
 * nuts has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 */


namespace Model;

use Base\BaseModel;
use Handler\DataValidationException;

class CategoryModel extends BaseModel
{
    protected $table = "category";

    protected $aliasTable = "cat";

    protected $primaryKey = "ID";
    protected $fillable = ["BannerImagePath", "ClothingStyleID", "Code", "CreatedBy", "CreatedDate", "Description", "DisplayImagePath", "FriendlyURL", "IsActive", "IsShoe", "MetaDescription", "MetaKeyword", "MetaTitle", "Name", "ShowInMenu", "Status", "UpdatedBy", "UpdatedDate"];

    public function joinRelationClothingstyle($alias = "clothing_style")
    {
        $this->query->join("clothing_style as $alias", "$alias.ID", "=", "cat.ClothingStyleID");
        return $this;
    }


    public function beforeEnterIntoDatabase()
    {
        if (empty($this->ClothingStyleID)) {
            throw new DataValidationException("ClothingStyleID cannot be null");
        }
        if (empty($this->Code)) {
            throw new DataValidationException("Code cannot be null");
        }
        if (empty($this->CreatedBy)) {
            throw new DataValidationException("CreatedBy cannot be null");
        }
        if (empty($this->CreatedDate)) {
            throw new DataValidationException("CreatedDate cannot be null");
        }
        if (empty($this->FriendlyURL)) {
            throw new DataValidationException("FriendlyURL cannot be null");
        }
        if (empty($this->IsActive)) {
            throw new DataValidationException("IsActive cannot be null");
        }
        if (empty($this->MetaDescription)) {
            throw new DataValidationException("MetaDescription cannot be null");
        }
        if (empty($this->MetaKeyword)) {
            throw new DataValidationException("MetaKeyword cannot be null");
        }
        if (empty($this->MetaTitle)) {
            throw new DataValidationException("MetaTitle cannot be null");
        }
        if (empty($this->Name)) {
            throw new DataValidationException("Name cannot be null");
        }
        if (empty($this->Status)) {
            throw new DataValidationException("Status cannot be null");
        }
        $Clothingstyle = (new \Model\ClothingstyleModel)->findById($this->ClothingStyleID);
        if (empty($Clothingstyle)) {
            throw new DataValidationException("ClothingStyleID Invalid Relation ID");
        }
        return $this;
    }
}